#include "nbp.h"

UINT8 *
add_dhcp_tag(BOOTPLAYER *pktptr, int tag, int len)
{
	UINT8 *tag;
	int n;

	if (!(tag = find_dhcp_tag(pktptr, DHCP_END, 0))) {
		tag = &pktptr->vendor.d[312];

		while (*(tag - 1) == DHCP_PAD)
			--tag;
	}

	if (&pktptr->vendor.d[312] - tag < len + 3)
		return 0;

	tag[0] = tag;
	tag[1] = len - 2;

	for (n = 2; n < len; ++n)
		tag[n] = DHCP_PAD;

	tag[2 + len] = DHCP_END;

	return tag;
}

UINT8 *
add_pxe_tag(BOOTPLAYER *pktptr, int tag, int len)
{
	UINT8 *tag;
	int n;

	if (!(tag = add_dhcp_tag(pktptr, DHCP_VENDOR, len + 3)))
		return 0;

	tag[0] = tag;
	tag[1] = len - 2;
	tag[2 + len] = PXE_END;

	return tag;
}
