#include "nbp.h"

extern BOOTPLAYER reply;

extern t_IP gateway;

t_PXENV_RESTART_TFTP restart;

int
do_restart()
{
	t_DHCP_BOOTFILE *bootfile;
	t_DHCP_OVRLOAD *ovrload;
	t_DHCP_SRVID *srvid;
	t_PXE_MTFTP_IP *mtftp_ip;
	t_PXE_MTFTP_CPORT *mtftp_cport;
	t_PXE_MTFTP_SPORT *mtftp_sport;
	t_PXE_MTFTP_TMOUT *mtftp_tmout;
	t_PXE_MTFTP_DELAY *mtftp_delay;

	if (bootfile = find_dhcp_tag(&reply, DHCP_BOOTFILE, 0)) {
		strncpy(restart.FileName, bootfile->buf, bootfile->len);
		restart.FileName[bootfile->len] = 0;
	} else {
		if (ovrload = find_dhcp_tag(&reply, DHCP_OVRLOAD, 0)) {
			if (ovrload->type & 1) {
				bputs("\nPXE-Exx: No bootfile name.\n");
				return;
			}
		}

		if (!*reply.bootfile) {
			bputs("\nPXE-Exx: No bootfile name.\n");
			return;
		}

		strcpy(restart.FileName, reply.bootfile);
	}

	restart.Status = PXENV_STATUS_SUCCESS;

	restart.BufferSize = (unsigned long)fbms() << 10;

	restart.BufferOffset = 0x7C00L;

	if (srvid = find_dhcp_tag(&reply, DHCP_SRVID, 0))
		*(t_IP *)restart.ServerIPAddress = *(t_IP *)&srvid->ip;

	if (!*(t_IP *)restart.ServerIPAddress)
		*(t_IP *)restart.ServerIPAddress = *(t_IP *)reply.sip;

	if (!*(t_IP *)restart.ServerIPAddress) {
		bputs("\nPXE-Exx: No boot server IP address.\n");
		return;
	}

	*(t_IP *)restart.GatewayIPAddress = gateway;

	*(t_IP *)restart.McastIPAddress = 0;
	restart.TFTPClntPort = INTSWAP(0);
	restart.TFTPSrvPort = INTSWAP(0);
	restart.TFTPOpenTimeOut = 0;
	restart.TFTPReopenDelay = 0;

	if ((mtftp_ip = find_pxe_tag(&reply, PXE_MTFTP_IP, 0)) &&
		(mtftp_cport = find_pxe_tag(&reply, PXE_MTFTP_CPORT, 0)) &&
		(mtftp_sport = find_pxe_tag(&reply, PXE_MTFTP_SPORT, 0)) &&
		(mtftp_tmout = find_pxe_tag(&reply, PXE_MTFTP_TMOUT, 0)) &&
		(mtftp_delay = find_pxe_tag(&reply, PXE_MTFTP_DELAY, 0))) {

		*(t_IP *)restart.McastIPAddress = *(t_IP *)mtftp_ip->ip;
		restart.TFTPClntPort = intswap(mtftp_cport->port);
		restart.TFTPSrvPort = intswap(mtftp_sport->port);
		restart.TFTPOpenTimeOut = mtftp_tmout->tmout;
		restart.TFTPReopenDelay = mtftp_delay->delay;
	}

#if 0
	bputs("\nFileName: "); bputs(restart.FileName);
	bputs("\nBufferSize: "); bputu32(restart.BufferSize);
	bputs("\nBufferOffset: "); bputh8(restart.BufferOffset);
	bputs("\nServerIPAddress: "); bputip(*(t_IP *)restart.ServerIPAddress);
	bputs("\nMcastIPAddress: "); bputip(*(t_IP *)restart.McastIPAddress);
	bputs("\nTFTPClntPort: "); bputu16(intswap(restart.TFTPClntPort));
	bputs("\nTFTPSrvPort: "); bputu16(intswap(restart.TFTPSrvPort));
	bputs("\nTFTPOpenTimeOut: "); bputu16(restart.TFTPOpenTimeOut);
	bputs("\nTFTPReopenDelay: "); bputu16(restart.TFTPReopenDelay);
	bputs("\nrestart()...");
#endif

	switch_stack();

	pxe(PXENV_RESTART_TFTP, &restart, _DS());

	switch_stack();

	bputs("\nPXE-Exx: Error downloading file.\n");
}
