#include "nbp.h"

t_PXENV_RESTART_TFTP _restarttftp;

int
tftpgetfsize(UINT32 *fsize, char *fname, t_IP sip, t_IP gw)
{
	t_PXENV_TFTP_GET_FSIZE tftpgetfsize;

	tftpgetfsize.Status = PXENV_STATUS_SUCCESS;

	tftpgetfsize.FileSize = 0;

	strcpy(tftpgetfsize.FileName, fname);

	*(t_IP *)tftpgetfsize.ServerIPAddress = sip;

	*(t_IP *)tftpgetfsize.GatewayIPAddress = gw;

	pxe(PXENV_TFTP_GET_FSIZE, &tftpgetfsize, _SS());

	*fsize = tftpgetfsize.FileSize;

	return tftpgetfsize.Status;
}

int
tftpreadfile(UINT32 bufaddr, UINT32 *bufsize, char *fname, t_IP sip, t_IP gw, t_IP mip, int cport, int sport, int tmout, int delay)
{
	t_PXENV_TFTP_READ_FILE tftpreadfile;

	tftpreadfile.Status = PXENV_STATUS_SUCCESS;

	tftpreadfile.BufferOffset = bufaddr;

	tftpreadfile.BufferSize = *bufsize;

	strcpy(tftpreadfile.FileName, fname);

	*(t_IP *)tftpreadfile.ServerIPAddress = sip;

	*(t_IP *)tftpreadfile.GatewayIPAddress = gw;

	*(t_IP *)tftpreadfile.McastIPAddress = mip;

	tftpreadfile.TFTPClntPort = intswap(cport);

	tftpreadfile.TFTPSrvPort = intswap(sport);

	tftpreadfile.TFTPOpenTimeOut = tmout;

	tftpreadfile.TFTPReopenDelay = delay;

	pxe(PXENV_TFTP_READ_FILE, &tftpreadfile, _SS());

	*bufsize = tftpreadfile.BufferSize;

	return tftpreadfile.Status;
}

int
restarttftp(char *fname, t_IP sip, t_IP gw, t_IP mip, int cport, int sport, int tmout, int delay)
{
	_restarttftp.Status = PXENV_STATUS_SUCCESS;

	_restarttftp.BufferOffset = 0x7C00L;

	_restarttftp.BufferSize = fbms() * 1024L;

	*(t_IP *)_restarttftp.ServerIPAddress = sip;

	*(t_IP *)_restarttftp.GatewayIPAddress = gw;

	*(t_IP *)_restarttftp.McastIPAddress = mip;

	_restarttftp.TFTPClntPort = intswap(cport);

	_restarttftp.TFTPSrvPort = intswap(sport);

	_restarttftp.TFTPOpenTimeOut = tmout;

	_restarttftp.TFTPReopenDelay = delay;

	switch_stack();

	pxe(PXENV_TFTP_READ_FILE, &_restarttftp, _DS());

	switch_stack();

	return _restarttftp.Status;
}
